/* kontrol.proto.h */
/* contient les prototypes de kontrol.c */


#define UNK_ERROR		-2	/* unknown error		*/
#define PROC_FINISHED		-3	/* process fini			*/
#define EXCEEDS_MEM_KO		-4	/* process excede taille memoire*/
#define EXCEEDS_CPUTIME		-5	/* process exceeds cputime	*/
#define USER_CANCELLED		-6	/* user cancels (mouse click)   */
#define BAD_KMR_EXIT		-7	/* bad execution of process	*/
#define NOT_LAUNCHED		-8	/* program not launched		*/
#define ZOMBIE_PROCESS		-9	/* process is zombie	*/

#define FATHER_TIME_OUT         20      /* delai d'attente pour le      */
					/* signal SIGALRM de kmrxpp     */

#ifdef THINK_C
#include <unix.h>
#include <string.h>
#else /* not THINK_C */
#include <unistd.h>
#include <sys/types.h>
#include <sys/signal.h>
#include <sys/wait.h>
#endif /* not THINK_C */

/* defines for pipe */

#define FILE_CHANNEL    1               /* output to kmrxpp is a file   */
#define PIPE_CHANNEL    2               /* output to kmrxpp is a file   */


#ifndef Darwin
int	control_prog(char *prog_name, pid_t pid, int maxcputime,
		int maxpageKo, char **err_msg);
#else
int control_prog(char *prog_name, pid_t prog_pid, int maxcputime,
                int maxmemKo, char **err_msg);
#endif /* Darwin */
