/* minimier et quicksort	*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*
#include "libstki.h"
#include "libstkp.h"
*/
#include "swelfe.h"
#include "swalign.h"
#include "lecture.h"
#include "minimier.h"
#include "macros.h"




					/* statiques	*/
static ctree 	*sArbreScan = NULL;
static int	sI_tree_max;		/* sArbreScan len	*/
static int      skeep_struct=0; /*nb de meilleurs a garder reellement*/
static int      sArbreTrie=PASBON;

static ctree   *sNewTree(int nb_nodes);
static void	sUpdateMinimier(int depth, SWResult *swres, double (*getscore)(void *), int (*compar)(double, double));
static void	sort_arbre(int (*qscompar)(const void *, const void *));

/* static double TrouveMinRMS(double *tRMSDCroises, int nbMots); */


/* ----------------------------------------------------------- */
/*Get_Prot: RENVOYER LA PROTINE DE RANG VOULU rang            */
/*Attention, ne pas l'utiliser si il y a encore des protines  */
/* classer: je ne sais pas ce que a fait de trier l'arbre    */
/*en plein milieu ( priori rien mais bon)                     */
/* ----------------------------------------------------------- */
/*Renvoie un pointeur sur la proteine de rang rang,            */
/*NULL si pas/plus de proteine a ce rang*/
/* ----------------------------------------------------------- */
SWResult *get_minimier_swres(int rang, int (*qscompar)(const void *, const void *))
{

  if (sArbreTrie==PASBON)
    sort_arbre(qscompar);

  if(rang < skeep_struct && sArbreScan[rang].score >= 0.0) 
    return(sArbreScan[rang].swres);
  else
    return(NULL);

} /*Fin de Get_Prot*/

/* ----------------------------------------------------------- */
void init_minimier(int keep_struct)
{

			/* -------------------------------- */
			/* calcul de la puissance de 2		*/
			/* immediatement >  keep_struct		*/
  int i;		/* -------------------------------- */	

   for (sI_tree_max = 1, i=0 ; (sI_tree_max - 1) < keep_struct ; sI_tree_max *= 2, i++)
			; /* nop */
   sI_tree_max--;
/*    fprintf(stderr, "nb cases minimier: %d, i: %d\n", sI_tree_max, i); */
   skeep_struct=keep_struct;
   if (! (sArbreScan = sNewTree(sI_tree_max))) {
      fprintf(stderr, "init_minimier:: Error: Not enough memory for result tree");
      exit(ERR_MINIMIER);
   }
  
   
}

/* ----------------------------------------------------------- */

void Free_Minimier(void)
{
  int i;

  if(sArbreScan==NULL) {
	fprintf(stderr, "Pas de minimier a desallouer\n");
        return;
  }

  for (i=0; i<sI_tree_max; i++) {
     if(sArbreScan[i].score > -2.0) {
        FreeSWResult(sArbreScan[i].swres, FREEPROT);
     }
  }
  free(sArbreScan);
  sArbreScan=NULL;

  return;
}

/* ----------------------------------------------------------- */

void ReInit_Minimier(void)
{
  int i;

  if(sArbreScan==NULL){fprintf(stderr, "Pas de minimier a desallouer\n"); return;}

  for (i=0; i<sI_tree_max; i++) {
        sArbreScan[i].score=-2.0;
	sArbreScan[i].swres = NULL;
  }
  return;

}

/* ----------------------------------------------------------- */
double GetSWScore(void *s)
{
   return ((SWResult *)s)->score[0];
}
/* ----------------------------------------------------------- */
double GetSWRMS(void *s)
{
   return ((SWResult *)s)->new_rms[0];
}


/* ----------------------------------------------------------- */
int ComparScore(double s1, double s2)
{
  if (s1 > s2)
    return 1;
  else if (s1 < s2)
       return -1;
  else
    return 0;
}

/* ----------------------------------------------------------- */
int ComparNewRMS(double r1, double r2)
{
  if (r1 < r2)
    return 1;
  else if (r1 > r2)
       return -1;
  else
    return 0;
}

/* ----------------------------------------------------------- */
SWResult *range(SWResult *s, double (*getscore)(void *), int (*compar)(double, double))
{
   SWResult	*mins = s;
				/* update minimier only	*/
				/* if it's needed	*/
/*    fprintf(stderr, "pProt: %p\n", p); */
/*    fprintf(stderr, "%s\n", p->pdbpath); */
/*    fprintf(stderr, "score %d\n", p->pResult->scoreTot); */
/*    fprintf(stderr, "ds range_pProt, score: %d\n", SCORE(p)); */

   if (sArbreTrie == BON) {
     fprintf(stderr,"%s%s%s%s", 
	     "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n",
	     "Minimier tree was sorted before all proteins were ranked\n",
	     "Results impredictable\n",
	     "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
     sArbreTrie = PASBON;
   }

/*    fprintf(stderr, "range_pProt:: range prot %s, score %f\n", p->nomProt, SCORE(p)); */
    if(getscore(s) < 0.0L)
     fprintf(stderr, "!!!!!!!!!!!!!!! I think the score hasn't been computed: %f\n", getscore(s));
   if (compar(getscore(s), sArbreScan->score) == 1) { /* si meilleur, on le rentre dans minimier */
     mins = sArbreScan->swres;
     sUpdateMinimier(sI_tree_max/2, s, getscore, compar);
   }
   return mins;

}





/* -------------------------------------------------------------------- */
/* fonction de comparaison de cellules de minimier pour quick_sort	*/
/* (pour tri en ordre decroissant)					*/
/*								      	*/
/* @Function sCtreeComparDecroissant(x, y)				*/
/* -------------------------------------------------------------------- */
int sCtreeComparDecroissant(const void *x, const void *y)
{
  return( ( ((ctree *)x)->score > ((ctree *)y)->score) ? -1 : ((ctree *)x)->score < ((ctree *)y)->score ? +1 : 0); 

} /* end of int sCtreeComparDecroissant(x, y) */

/* -------------------------------------------------------------------- */
/* fonction de comparaison de cellules de minimier pour quick_sort	*/
/* (pour tri en ordre croissant)					*/
/*								      	*/
/* @Function sCtreeComparCroissant(x, y)				*/
/* -------------------------------------------------------------------- */
int sCtreeComparCroissant(const void *x, const void *y)
{
  return( ( ((ctree *)x)->score > ((ctree *)y)->score) ? +1 : ((ctree *)x)->score < ((ctree *)y)->score ? -1 : 0); 

} /* end of int sCtreeComparCroissant(x, y) */

/* -------------------------------------------------------------------- */
/* creation d'un arbre minimier						*/
/* (allocation memoire et initialisation)			*/
/*							    */
/* @Function sNewTree(nb_nodes)						*/
/* -------------------------------------------------------------------- */
static ctree *sNewTree(int nb_nodes)
{
	int i;
	ctree	*arbre;
	ctree	*c_arbre;


	if ((arbre = NEWN(ctree, nb_nodes)) == NULL) {
           return NULL;
        }
	c_arbre = arbre;

	if (c_arbre) 
	  for (i = 0 ; i < nb_nodes ; i++, c_arbre++) {
		  c_arbre->score = -2.0;
		  c_arbre->swres=NULL;
	}
	return arbre;
} /* end of ctree * sNewTree(nb_nodes) */

/* -------------------------------------------------------------------- */
/* fonction de mise a jour d'un minimier (version inversee)		*/
/*								    	*/
/* @Function sUpdateMinimier						*/
/* -------------------------------------------------------------------- */
static void sUpdateMinimier(int depth, SWResult *swres, double (*getscore)(void *), int (*compar)(double, double))
{
	int		i;
	ctree 	*c_arbre, *l_arbre, *r_arbre, *e_arbre;



					/* depth: nombre de noeuds/2 	*/

	for (c_arbre = sArbreScan, i = 0 ; i < depth ; ) {	
	    

					/* 2*i+1: gauche	*/
	    i = (i << 1) | 0x1;	      /* fils gauche 	*/


	    r_arbre = e_arbre = l_arbre = sArbreScan + i;
	    r_arbre++;
				
	    if (compar(r_arbre->score, l_arbre->score) == -1) {
			e_arbre++;
			i++;
	    }				
				     /* fin remise a jour	*/

	    if (compar(getscore(swres), e_arbre->score) == 1) {
 	      *c_arbre = *e_arbre;            /* transfert cells */ 
 	      c_arbre =  e_arbre; 
	    }
            else
	      {
                        break;
	      }
	}
	c_arbre->score  = getscore(swres);	
	c_arbre->swres=swres;
	return;

} /* end of void sUpdateMinimier */


/* ----------------------------------------------------------- */
static void sort_arbre(int (*qscompar)(const void *, const void *))
{

/*   fprintf(stderr, "ds sort_arbre\n"); */

 qsort((void *)sArbreScan, (size_t)sI_tree_max, sizeof(ctree),
       (int (*)(const void *, const void *))qscompar);

  return;

}

