/* ---------------------------------------------------- */
/* SpIMac V 0.0 					*/
/* <Gloup> Nov. 93					*/
/*							*/
/* @file: st_gammln.c					*/
/*							*/
/* Gamma function related				*/
/*							*/
/* @globals:						*/
/*	<none>						*/
/* ---------------------------------------------------- */
/*							*/
/* taken "as is" from NUMERICAL RECIPES			*/
/* original file :  GAMMLN.C				*/
/*							*/
/* ---------------------------------------------------- */

#include <math.h>

#include "nr_util.h"
#include "st.h"

double gammln(double xx)

{
        double x,tmp,ser;
        static double cof[6]={76.18009173,-86.50532033,24.01409822,
                              -1.231739516,0.120858003e-2,-0.536382e-5};
        int j;

        x=xx-1.0;
        tmp=x+5.5;
        tmp -= (x+0.5)*log(tmp);
        ser=1.0;
        for (j=0;j<=5;j++) {
                x += 1.0;
                ser += cof[j]/x;
        }
        return -tmp+log(2.50662827465*ser);
}
