/* ---------------------------------------------------- */
/* SpIMac V 0.0 					*/
/* <Gloup> Nov. 93					*/
/*							*/
/* @file: st_gammq.c					*/
/*							*/
/* Gamma function related				*/
/*							*/
/* @globals:						*/
/*	<none>						*/
/* ---------------------------------------------------- */
/*							*/
/* taken "as is" from NUMERICAL RECIPES			*/
/* original file :  GAMMQ.C				*/
/*							*/
/* ---------------------------------------------------- */

#include "nr_util.h"
#include "st.h"

double gammq(double a, double x)

{
        double gamser,gammcf,gln;

        if (x < 0.0 || a < 0.0) nrerror("Invalid arguments in routine GAMMQ");
#if 1
	if (a==0.0) return (double)-1.0 ;
#endif
        if (x < (a+1.0)) {
                gser(&gamser,a,x,&gln);
                return 1.0-gamser;
        } else {
                gcf(&gammcf,a,x,&gln);
                return gammcf;
        }
}

