/* ---------------------------------------------------- */
/* SpIMac V 0.0 					*/
/* <Gloup> Nov. 93					*/
/*							*/
/* @file: st_gser.c					*/
/*							*/
/* Gamma function related				*/
/*							*/
/* @globals:						*/
/*	<none>						*/
/* ---------------------------------------------------- */
/*							*/
/* taken "as is" from NUMERICAL RECIPES			*/
/* original file :  GSER.C				*/
/*							*/
/* ---------------------------------------------------- */

#include <math.h>

#include "nr_util.h"
#include "st.h"

#define ITMAX 100
#define EPS 3.0e-7

void gser(double *gamser, double a, double x, double *gln)

{
        int n;
        double sum,del,ap;

        *gln=gammln(a);
        if (x <= 0.0) {
                if (x < 0.0) nrerror("x less than 0 in routine GSER");
                *gamser=0.0;
                return;
        } else {
                ap=a;
                del=sum=1.0/a;
                for (n=1;n<=ITMAX;n++) {
                        ap += 1.0;
                        del *= x/ap;
                        sum += del;
                        if (fabs(del) < fabs(sum)*EPS) {
                                *gamser=sum*exp(-x+a*log(x)-(*gln));
                                return;
                        }
                }
                nrerror("a too large, ITMAX too small in routine GSER");
                return;
        }
}

#undef ITMAX
#undef EPS
