


#define NBRESULTS	5


#ifndef _H_Nmatrix
#include "Nmatrix.h"
#endif

#ifndef ABS
#define ABS(X)       (((X) > 0) ? (X) : (-(X)))
#endif

#define TOO_MUCH_RECOVER		-2.0
#define NOT_PCMAX		-1.0
#define INCPP	10		/* nb of initial and increment for	*/
				/* array of rms (pp0,pp1 and lensub)	 in swalign*/

#define ADN_MULT	10	/* multiplication du match/mismatch ADN pour passer en entier */
#define SWADN_MULT	1.0	/* multiplication du match/mismatch ADN pour swalign pour test */
#define PROT_MULT	1	/* multiplication du match/mismatch Proteine pour passer en entier */

#define FREEPROT	0
#define NOFREEPROT	1

/*
OLD SWResult swa defined here
*/

typedef struct {
   float *f;
   char  *c;
   int   rsize;
   int   n1,n2;
} Matrix;

typedef struct coord_ext {
    unsigned short coord;
    float score;
} coord_ext;


SWResult *swalign(tyProt *p0, tyProt *p1, int automode, int nresult,
		float minscore, float proba_limite, float minrms, 
		float (*gscore)(int a1, int a2, void *matthresh), void *mat_thresh, float gap_o, float gap_e,
		float tauxrecouv, float cross_rms_seuil, int vverbose, int SPN, WV *water_ving,
                int length, int elongation, float rrmsd, int which_rmsd);

float aascore(int a1, int a2, pam_matrix *mat);
float anuc_score(int a1, int a2, pam_matrix *mat);
float blosum_anglescore(int a1, int a2, float *threshold);
float anglescorenouveau(int a1, int a2, float *threshold);

int Ianuc_score(int a1, int a2, pam_matrix *mat);
int Iaascore(int a1, int a2, pam_matrix *mat);
int Ianglescorenouveau(int a1, int a2, float *threshold);

void compute_nuc_matrix(pam_matrix *matrix, float *freq, float *gap);

void FreeSWResult(SWResult *swres, int freeprot);
void PrintResult(FILE *fout, SWResult *swres, tyProt *p0, int proba, int SPN, float moyenne, float ecart_type);
void PrintResult2(FILE *fout, SWResult *swres, tyProt *p0, int proba, int SPN, float moyenne, float ecart_type, float *mat_or_thresh, float gap_o, float gap_e);


float maximum_5 (float a, float b, float c, float d, float e);
#if 0
float anglescore(int a1, int a2, float *threshold);
float anglescorebis(int a1, int a2, float *threshold);
float anglescoreter(int a1, int a2, float *threshold);
float anglescorecarre(int a1, int a2, float *threshold);
#endif

 void AddSWResult(SWResult *swres, float score, double rms, float rev_rms,
		float recover, int posd0, int posd1,
			int posf0, int posf1, char *salign, DtMatrix4x4 matrix4x, double score_GL, 
			float score_blosangle, double tm_score, float alpha, float beta, float gamma, double new_rms); 

/* void PrintMatrixRT(double *matrixRT);*/
void FreeMatrix(void);

 int MakeCoordFromAlign(COORDS *p0, COORDS *p1, char *sali,
			COORDS **pp0, COORDS **pp1);

void PrintIdAli(FILE *fout, tyProt *p1, int posd1, 
		       tyProt *p2, int posd2, char *sali, int *score_blosum, int SPN);
void CalculIdAli(tyProt *p1, int posd1, 
		       tyProt *p2, int posd2, char *sali, int *score_blosum);

 void PrintAliSeq(FILE *fout, tyProt *p, int pos, char *sali, char inser);



void CalculBlosumAngles(tyProt *p1, int posd1, 
		       tyProt *p2, int posd2, char *sali, float *score_blosum_angle);
void CalculScoreAngles(tyProt *p1, int posd1, 
		       tyProt *p2, int posd2, char *sali, float *score_angle);


void Print_mat(void);
void Print_mat2(void);
void Print_mat3(void);

SWResult *NewSWResult(tyProt *p);

/*swalign2.c*/
void tri_3 (float **tab, int longueur);
void FreeMatrix_Gap(void);

int backtracking (Matrix *m, int *s1, int *n1, int *s2, int *n2,int *posd1, int *posd2, int *posf1, int *posf2,
        char *s, char *lastmove,unsigned short **gap_ext , char *salign, int besti, int bestj);


float alignsw_f(Matrix *m, int *s1, int n1, int *s2, int n2,
			int automode, float gap_o, float gap_e,
			void *mat_or_thresh, float tauxrecouv,
			int *posd1, int *posd2, int *posf1, int *posf2,
			char *salign, float *recover,
			float (*gscore)(int a1, int a2, void *matthresh), float **best_scores, 
			int icarre, int jcarre, coord_ext **ii, coord_ext **jj, unsigned short **gap_ext,
                        int *nb_best_scores, int *ali_len);


int carre_sw (SWResult *swres, Matrix *m, tyProt *p0, tyProt *p1, int automode, 
        float gap_o, float gap_e, float (*gscore)(int a1, int a2, void *matthresh), void *mat_thresh,  
        float tauxrecouv,float recover, int vverbose, int SPN, 
        int nresult, float minscore, float proba_limite, float minrms,float cross_rms_seuil, 
        int **plensub, int nbpp, COORDS ***ppp0, COORDS ***ppp1, WV *water_ving, int length, int elongation, float rrmsd, int which_rmsd );
        
int calculRMS ( int *nbpp, int **plensub, COORDS ***ppp0, COORDS ***ppp1, tyProt *p0, tyProt *p1, char *salign,
            double *rms, float  *reverse_rms ,  SWResult*swres, float *score,float *score_blosangle, float recover, int *posd0, 
            int *posd1, int posf0, int posf1, DtMatrix4x4 matrix4x, int *n, float     minscore ,float minrms, int verbose, int elongation , 
            float rrmsd, int which_rmsd, int automode);
void makegroup(int premier, int dernier, float **crossrms, int *group, int *ngroup, float cross_rms_seuil);
void sPrintMatrix(Matrix *m);

double proba_water_ving(WV *water_ving, double score, int n);
