
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "macros.h"
#include "swelfe.h"

#ifdef GSL
#include "gsl/gsl_math.h"
#include "gsl/gsl_eigen.h"
#include "gsl/gsl_linalg.h"
#endif

/*
#include "gsl/gsl_matrix.h"
#include "gsl/gsl_blas.h"
#include "gsl/gsl_complex.h"
#include "gsl/gsl_complex_math.h"
#include "gsl/gsl_mode.h"
#include "gsl/gsl_permutation.h"
#include "gsl/gsl_permute_complex_double.h"
#include "gsl/gsl_types.h"
#include "gsl/gsl_errno.h"
#include "gsl/gsl_check_range.h"
#include "gsl/gsl_vector_double.h"
#include "gsl/gsl_vector_complex.h"
#include "gsl/gsl_block_complex_double.h"
*/

#include "swalign.h"
#include "lecture.h"
#include "util.h"
#include "libabiutils.h"
#include "score_struct.h"
#include "fonctions_main.h"
#include "kontrol.proto.h"  /*pour controler la memoire*/


#define INFINI 10000000   /* 10e 7*/
#define NB_BEST_SCORES_INI    50
#define PLUSPLUS 1
/*matrices d'extension de gap !! */
static  int sNb_gap_ext0 = 0;
static  int sNb_gap_ext1 = 0;
static  coord_ext **sIi = NULL, **sJj = NULL; /*extention de gaps : matrice de la taille de sw : memoire score et position d'ou on vient*/
static unsigned short **gap_ext = NULL;   /*pour les extentions de gap : contient les "sauts de gap" : nb de cases a sauter*/



/*#define MEMOIRE 1 */

/*#define TRU*/
/*#define TRUC*/
/*#define TRUC2*/


/*libere les matrices d'extension de gap*/
void FreeMatrix_Gap(void) {
    int j;

    if (sIi)
        for (j=0; j<sNb_gap_ext1; j++)
            MYFREE(sIi[j]);
    MYFREE(sIi);


    if (sJj)
        for (j=0; j<sNb_gap_ext1; j++)
            MYFREE(sJj[j]);
    MYFREE(sJj);

    if (gap_ext)
        for (j=0; j<sNb_gap_ext1; j++)
            MYFREE(gap_ext[j]) ;
    MYFREE(gap_ext) ;


}


/*fonction de tri d'un tableau a 3 lignes*/

void tri_3_bis (float **tab, int longueur) {

    int i, j;
    float tmp0, tmp1, tmp2;

    if (longueur > 1) {
        for (i=0; i<longueur; i++) {

            for (j=i+1; j<longueur; j++) {
                if (tab[j][0]<tab[i][0]) {
                    tmp0 = tab[i][0];
                    tmp1 = tab[i][1];
                    tmp2 = tab[i][2];
                    tab[i][0] = tab[j][0];
                    tab[i][1] = tab[j][1];
                    tab[i][2] = tab[j][2];
                    tab[j][0] = tmp0;
                    tab[j][1] = tmp1;
                    tab[j][2] = tmp2;
                }
            }
        }
    }
}

void tri_3 (float **tab, int longueur) {
    /*longueur =  taille du tableau */
    int i;
    float tmp0, tmp1, tmp2;
    int perm =1 ;
    int taille = longueur;

    while (perm == 1) {
        perm = 0;
        for (i=0; i<taille -1; i++) {
            if (tab[i][0]<tab[i+1][0]) {
                tmp0 = tab[i][0];
                tmp1 = tab[i][1];
                tmp2 = tab[i][2];
                tab[i][0] = tab[i+1][0];
                tab[i][1] = tab[i+1][1];
                tab[i][2] = tab[i+1][2];
                tab[i+1][0] = tmp0;
                tab[i+1][1] = tmp1;
                tab[i+1][2] = tmp2;
                perm = 1;
            }

        }
        taille --;
    }


}

void reremplit_tableau(int *nb_best_scores, float ** best_scores, int n1, int n2, int automode, float *pc, char *cc, Matrix *m) {

    int i, j;

    *nb_best_scores =  NB_BEST_SCORES_INI; /*on reremplit tout le tableau*/

    for (i=0; i< *nb_best_scores; i++) {/*initialisation du tableau*/
        best_scores[i][0] = 0.0;
        best_scores[i][1] = 0.0;
        best_scores[i][2] = 0.0;
    }



    for (i=1; i<=n2; i++) {
        if (automode)
            j=i;
        else
            j=1;
        for (; j <= n1; j++) {
            pc = m->f + (n1+1)* i + j;
            cc = m->c + (n1+1)*i + j;

            if (*cc != FORBI && *pc > best_scores[*nb_best_scores-1][0]) {  /*comparaison au score le plus faible*/
                best_scores[*nb_best_scores-1][0] = *pc;
                best_scores[*nb_best_scores-1][1] = i;
                best_scores[*nb_best_scores-1][2] = j;
                tri_3(best_scores, *nb_best_scores);
            }
        }
    }

}




int backtracking (Matrix *m, int *s1, int *n1, int *s2, int *n2,int *posd1, int *posd2, int *posf1, int *posf2,
                  char *s, char *lastmove,unsigned short **gap_ext , char *salign, int besti, int bestj) {


    float   *pc;
    char *cc;
    int k, tmp, nsub;
    /* positioning pointers */
    pc = m->f + (int)(besti)*(*n1+1) + (int)(bestj);
    cc = m->c + (int)(besti)*(*n1+1) + (int)(bestj);


    /* pos[f,d][0,1] are positions  */
    /* in the real structures, so   */
    /* they are position in the */
    /* matrix minus 1       */
    /* posd : pos begin     */
    /* posf : pos end       */
    *posd1 = *posf1 = (int)(bestj) - 1;  /*j*/
    *posd2 = *posf2 = (int)(besti) - 1;   /*i*/


    s = salign;
    nsub = 0;       /* number of substitutions  */
    *lastmove = FORBI;


    while (*pc > 0.0) {



        switch (*cc) {
        case SUBST:
            *pc = 0.0;
            pc = pc - *n1 - 2;
            *cc = FORBI;       /* forbids cell for next time   */
            cc = cc - *n1 - 2;
            (*posd1)--;
            (*posd2)--;
            *s++ = *lastmove = SUBST;
            nsub++;
            break;
        case INSER:
            if (gap_ext[*(posd2)+1][*(posd1)+1] != 0) {  /* extention de gap   */
                /*pc =  pc - gap_ext[*(posd2)+1][*(posd1) +1];*/
                tmp  = gap_ext[*(posd2)+1][*(posd1) + 1];
                for (k = 0; k < tmp ; k++) {
                    *pc = 0.0;
                    pc = pc -1;
                    *cc = FORBI;
                    cc = cc - 1;
                    *s++ = *lastmove = INSER;
                    (*posd1)--;
                }

            } else {
                *pc = 0.0;
                pc = pc - 1;
                *cc = FORBI;       /* forbids cell for next time   */
                cc = cc - 1;
                *s++ = *lastmove = INSER;
                (*posd1)--;
            }
            break;
        case DELET:
            if (gap_ext[*(posd2)+1][*(posd1)+1] != 0) {  /* extention de gap   */
                /*pc =  pc - (gap_ext[*(posd2)+1][*(posd1) + 1] * (*n1+1));*/
                tmp = gap_ext[*(posd2)+1][*(posd1) + 1] ;
                for (k = 0; k < tmp ; k++) {
                    *pc = 0.0;
                    pc = pc - *n1 - 1;
                    *cc = FORBI;
                    cc = cc - *n1 -1 ;
                    *s++ = *lastmove = DELET;
                    (*posd2) --;
                }

            } else {
                *pc = 0.0;
                pc = pc - *n1 - 1;
                *cc = FORBI;        /* forbids cell for next time   */
                cc = cc - *n1 - 1;
                *s++ = *lastmove = DELET;
                (*posd2)--;

            }
            break;
        default:
            fprintf(stderr,"alignsw:: cc <%c> %f is not s,i or d, this should not append!\n",*cc, *pc);
            *pc = 0.0; /*pour arreter la boucle !!!!*/
            sPrintMatrix(m);
            break;
        }
#ifdef DEBUGW
        fprintf(stderr,"next pc = %10.2f  (diff=%7.2f) posd0=%3d posd1=%3d\n",
                *pc, tmp-*pc,*posd2,*posd1);
#endif
    }
    *s = '\0';


    /* -----------------------------------  */
    /* le dernier move est a retrancher */
    /* puisque la case ou l'on arrive   */
    /* n'est pas a aligner          */
    /* de plus, il ne faut pas interdire    */
    /* la derniere cellule          */
    /* (cad celle la plus en haut a gauche) */
    /* -----------------------------------  */





    switch (*lastmove) {
    case SUBST:
        (*posd1)++;
        (*posd2)++;
#ifdef TRUC2
        fprintf(stderr,"ZERO : %c %f %c posd %d %d\n", *lastmove,*(pc +*n1 +2), *(cc + *n1 + 2), *posd1+1, *posd2+1);
#endif
        break;
    case INSER:
        (*posd1)++;
#ifdef TRUC2
        fprintf(stderr,"ZERO : %c %f %c posd %d %d\n", *lastmove,*(pc +1), *(cc + 1), *posd1+1, *posd2+1);
#endif
        break;
    case DELET:
        (*posd2)++;
#ifdef TRUC2
        fprintf(stderr,"ZERO : %c  %f %c posd %d %d\n", *lastmove,*(pc +*n1 +1), *(cc + *n1 + 1), *posd1+1, *posd2+1);
#endif
        break;
    default:
        fprintf(stderr,"alignsw:: lastmove <%c> is not s,i or d, this should not append!\n",*lastmove);
        fflush(stderr);
        break;
    }

#ifdef TRUC
    /*      pc = m->f + (*n1+1)*(*posd2-1) + *posd1-1;
    cc = m->c + (*n1+1)*(*posd2-1) + *posd1-1;*/
    fprintf(stderr,"lastmove : %c \n", *lastmove);

    fprintf(stderr,"valeur : %f %c posd %d %d\n", *pc, *cc, *posd2, *posd1);
#endif




    return nsub;
}



/* ---------------------------------------------------- */
/* alignement proprement dit        option _f       */
/* ---------------------------------------------------- */
float alignsw_f(Matrix *m, int *s1, int n1, int *s2, int n2,
                int automode, float gap_o, float gap_e,
                void *mat_or_thresh, float tauxrecouv,
                int *posd1, int *posd2, int *posf1, int *posf2,
                char *salign, float *recover,
                float (*gscore)(int a1, int a2, void *matthresh), float **best_scores,
                int icarre, int jcarre, coord_ext **ii, coord_ext **jj, unsigned short **gap_ext,
                int *nb_best_scores, int *nsub) {

#undef DEBUGQ

    /*
    n1
    --------- s1[j]------->
    |
    |
    s2[i]   ps      pd
    |              |
    |              d
    |              |
    |              v
    |      pi -i-> pc
    n2   v
    */
    int     i,j,  debut, flag;
    float   *pc=NULL,*ps=NULL,*pi=NULL,*pd=NULL;
    char    *s=NULL, lastmove,
               *cc=NULL;   /* cc is the path matrix    */
    /* if value is :        */
    /*  FORBI: forbidden cell   */
    /*  SUBST: substitution cell    */
    /*  INSER: insertion cell   */
    /*  DELET: deletion cell    */
    /*  ZERO: zero cell     */
    float ancien_pc=0.0,  ancien_gap_i=0.0, ancien_gap_j=0.0; /*pour comparer aux nouvelles valeurs*/
    float si = 0.0, sd = 0.0, ss=0.0;
    int position=0, taille;

    taille = (n1+1)*(n2+1);
    if (icarre == 1 && jcarre == 1) {  /*1ere fois qu'on est dans la fonction*/

        /*initialisation du tableau de scores*/
        for (i=0; i<*nb_best_scores; i++) {
            best_scores[i][0] = 0.0;
            best_scores[i][1] = 0.0;
            best_scores[i][2] = 0.0;
        }

        /* initialisation 1ere ligne et colonne et extention de gap*/

        pc = m->f;
        cc = m->c;
        position =0;
        *pc++ = 0.0;
        *cc++ = 'r';    /* root */

        for (j = 1; j <= n1; j++,pc++,cc++, position++) {
            *pc = 0.0;
            *cc = ZERO;
        }

        for (i = 1; i <= n2; i++,pc+=n1+1,cc+=n1+1, position +=n1+1) {

            *pc = 0.0;
            *cc = ZERO;
        }

        for (i=0; i<=n2; i++)
            for (j=0; j<=n1; j++)
                gap_ext[i][j] = 0;



#ifdef PLUSPLUS
        pc = m->f + n1 + 1;
        cc = m->c + n1 + 1;
        pi = pc - 1;
        pd = pc - n1 - 1;
        ps = pd - 1;
        position = n1+1;

#endif

        for (i = 1; i <= n2; i++) {

#ifdef PLUSPLUS
            if (! automode) {  /* jump over 1st column  (0) */
                pc++;
                pd++;
                pi++;
                ps++;
                cc++;
                position++;

            } else {         /* jump until i column  */
                pc+=i;
                pd+=i;
                pi+=i;
                ps+=i;
                cc+=i;
                position +=i;

            }

#endif
            /* in automode, only demi-matrix is  explored: j begin to i (diagonal)  */
            if (automode)    j=i;
            else               j = 1;
            for (j=j; j <= n1; j++
#ifdef PLUSPLUS
                    ,pc++,pd++,pi++,ps++,cc++, position++
#endif
                ) {

#ifndef PLUSPLUS
                pc = m->f + (n1+1)* i + j;
                cc = m->c + (n1+1)*i + j;
                pi = pc - 1;
                pd = pc - n1 - 1;
                ps = pd - 1;
#endif


                if (i == j && automode) {
                    /* if automode, diagonal is forbidden   */
                    *cc = FORBI;
                    *pc = 0.0;
                } else if (*cc == FORBI) {
                    /* if forbidden cell from previous run  */
                    *pc = 0.0;
                } else {

                    /*     remplit_matrice(cc, i, j, gap_o, gap_e, ii, jj, gap_ext, pc, ps, pi, pd, n1, n2,
                    gscore, mat_or_thresh, s1, s2);*/


                    if (*(cc-1) == FORBI) {
                        si = -1;
                        jj[i][j].score = -100;   /*interdit de traverser le match precedant*/
                        jj[i][j].coord = 0 ;
                    } else {
                        si = *pi + gap_o;
                        jj[i][j].score = jj[i][j-1].score + gap_e;
                        jj[i][j].coord = jj[i][j-1].coord ;
                    }

                    if (*(cc -n1 - 1) == FORBI) {
                        sd = -1;
                        ii[i][j].score = -100;
                        ii[i][j].coord = 0 ;
                    } else {
                        sd = *pd + gap_o;
                        ii[i][j].score = ii[i-1][j].score + gap_e;   /*calcul avec extention de gap : calcul du poids actuel avec insertion*/
                        ii[i][j].coord = ii[i-1][j].coord ;     /*id : mise en memoire de la case d'ou on a saute*/
                    }

                    if (*(cc -n1 - 2) == FORBI) {
                        ss = -1;
                    } else {
                        ss = *ps + gscore(s1[j-1],s2[i-1], mat_or_thresh);
                    }

#define MAX5(A,B,C,D,E,L,M,N,O,P,Q) \
if ((A) < 0.0) {\
if ((B) < 0.0) {\
if ((C) < 0.0) {\
if ((D) < 0.0) {\
if ((E) < 0.0) {\
L\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
else {\
if ( B > C ) {\
if (B > D) {\
if (B > E) {\
N\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
}\
else {\
if ( A > B) {\
if ( A > C) {\
if (A > D) {\
if (A > E) {\
M\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
else {\
if ( B > C ) {\
if (B > D) {\
if (B > E) {\
N\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
}


                    MAX5(ss, si, sd, ii[i][j].score, jj[i][j].score,
                         *pc = 0.0; *cc = ZERO;gap_ext[i][j] = 0; /*zzz++;  fprintf(stderr, "zzz\n");*/ ,
                         *pc = ss; *cc = SUBST;  gap_ext[i][j] = 0; /*aaa++; fprintf(stderr, "aaa\n");*/,
                         *pc = si; *cc = INSER;  gap_ext[i][j] = 0; /*bbb++;  fprintf(stderr, "bbb\n"); */,
                         *pc = sd;  *cc = DELET;  gap_ext[i][j] = 0; /*ccc++;  fprintf(stderr, "ccc\n");*/,
                         *pc = ii[i][j].score; *cc = DELET; gap_ext[i][j] = (int)(i - ii[i][j].coord); /*ddd++;  fprintf(stderr, "ddd\n");*/,
                         *pc = jj[i][j].score; *cc = INSER;  gap_ext[i][j] = j - jj[i][j].coord; /*eee++;  fprintf(stderr, "eee\n");*/
                        )


                    /*mise a jour de l'extention de gap*/

                    if (jj[i][j].score <= *(pc -1) + gap_o ) {
                        jj[i][j].score = *(pc -1) + gap_o;
                        jj[i][j].coord = j-1;
                    }
                    if (ii[i][j].score <= *(pc -n1 -1) + gap_o) {
                        ii[i][j].score = *(pc -n1 - 1 ) + gap_o;
                        ii[i][j].coord = i-1;
                    }


                    /* remember best    */
                    if (*pc > best_scores[*nb_best_scores-1][0]) {  /*comparaison au score le plus faible*/
                        best_scores[*nb_best_scores-1][0] = *pc;
                        best_scores[*nb_best_scores-1][1] = i;
                        best_scores[*nb_best_scores-1][2] = j;

                        tri_3(best_scores, *nb_best_scores);
                    }

                }  /*fin du else dans le for j*/

#ifdef PRINTMATRIX_
                sPrintMatrix(m);
#endif
            }   /* end for j */
        }   /* end for i */


    }  /*fin if c'est la premiere fois qu'on est dans la matrice*/




    /*si recalcule un bout : calcul le long du match precedant : */

    else {


        /*reinitialisation du meilleur score : */


#if 0
        /*on supprime la valeur qu'on vient de selectionner*/

        best_scores[0][0] = 0.0;
        best_scores[0][1] = 0.0;
        best_scores[0][2] = 0.0;

        /*on supprime toutes les valeurs qui sont sur le chemin qu'on a deja pris*/
        tri_3(best_scores,*nb_best_scores);  /*tri des valeurs du tableau*/

        for (i=0; i< *nb_best_scores; i++) {
            position = (int)(best_scores[i][1])*(n1+1) + (int)(best_scores[i][2]);

            cc = m->c + (int)(best_scores[i][1])*(n1+1) + (int)(best_scores[i][2]);
            if (*cc == FORBI) {
                best_scores[i][0] = 0.0 ;
                best_scores[i][1] = 0.0 ;
                best_scores[i][2] = 0.0;
            }
        }
        tri_3(best_scores, *nb_best_scores);

        reremplit_tableau(nb_best_scores, best_scores, n1, n2, automode, pc, cc, m);

        for (i=0; i<*nb_best_scores; i++)
            fprintf(stderr, "%f %f %f \n",best_scores[i][0], best_scores[i][1], best_scores[i][2] );
        fprintf(stderr, "\n");

#endif


        /*interdire 1ere case*/
        position =(n1+1)* icarre + jcarre;

        cc = m->c + (n1+1)*icarre + jcarre;
        pc = m->f + (n1+1)* icarre + jcarre;
        pi = pc - 1;
        pd = pc - n1 - 1;
        ps = pd - 1;
        *cc = FORBI;


        debut = jcarre;


        for (i = icarre; i<=n2; i++) {
            flag = 0;

            if (debut >= n1) {
                break;

            }


#if 0
            if (! automode) {  /* jump over 1st column  (0) */
                pc++;
                pd++;
                pi++;
                ps++;
                cc++;
            } else {         /* jump until i column  */
                pc+=i;
                pd+=i;
                pi+=i;
                ps+=i;
                cc+=i;
            }

#endif
            if (automode && debut<=i) /*il ne faut pas franchir la diagonale*/
                debut=i+1;

            for (j = debut; j <= n1; j++
#if 0
                    ,pc+=debut, cc+=debut, pi+=debut, pd+=debut, ps+=debut
#endif

                ) {

                position =(n1+1)* i + j;

                pc = m->f + (n1+1)* i + j;
                cc = m->c + (n1+1)*i + j;
                pi = pc - 1;
                pd = pc - n1 - 1;
                ps = pd - 1;

                /*mise en memoire pour comparer avec nouvelles valeurs*/
                ancien_pc = *pc;
                ancien_gap_i = ii[i][j].score;
                ancien_gap_j = jj[i][j].score;


                if (*cc== FORBI) {
                    /*case interdite, on met le tableau  jour si besoin*/
                    flag =1; /* on met le flag a 1 pour recalculer le reste du carre */

#if 0
                    k=0;
                    while (k<*nb_best_scores && (egal(best_scores[k][1], (float)(i))==0 || egal(best_scores[k][2], (float)(j))==0)) /*on cherche la case qui a garde le score precedant de i et j s'il existe*/
                        k++;

                    if (k < *nb_best_scores) {  /*on est dans le tableau : valeur a supprimer*/
                        best_scores[k][0] = 0.0;
                        best_scores[k][1] = 0.0;
                        best_scores[k][2] = 0.0;
                        tri_3(best_scores, *nb_best_scores);
                        if (best_scores[0][0] <= 0.00001) /*on reremplit le tableau*/
                            reremplit_tableau(nb_best_scores, best_scores, n1, n2, automode, pc, cc, m);
                    }
#endif
                    *pc = 0.0;

                } else {

                    /*  remplit_matrice(cc, i, j, gap_o, gap_e, ii, jj, gap_ext, pc, ps, pi, pd, n1, n2,
                    gscore, mat_or_thresh, s1, s2);
                    */
                    if (*(cc-1) == FORBI) {

                        si = -1;
                        jj[i][j].score = -100;   /*interdit de traverser le match precedant*/
                        jj[i][j].coord = 0 ;
                    } else {
                        si = *pi + gap_o;
                        jj[i][j].score = jj[i][j-1].score + gap_e;
                        jj[i][j].coord = jj[i][j-1].coord ;
                    }

                    if (*(cc -n1 - 1) == FORBI) {
                        sd = -1;
                        ii[i][j].score = -100;
                        ii[i][j].coord = 0 ;
                    } else {
                        sd = *pd + gap_o;
                        ii[i][j].score = ii[i-1][j].score + gap_e;   /*calcul avec extention de gap : calcul du poids actuel avec insertion*/
                        ii[i][j].coord = ii[i-1][j].coord ;     /*id : mise en memoire de la case d'ou on a saute*/
                    }


                    if (*(cc -n1 - 2) == FORBI) {
                        ss = -1;
                    } else {
                        ss = *ps + gscore(s1[j-1],s2[i-1], mat_or_thresh);
                    }


#define MAX5(A,B,C,D,E,L,M,N,O,P,Q) \
if ((A) < 0.0) {\
if ((B) < 0.0) {\
if ((C) < 0.0) {\
if ((D) < 0.0) {\
if ((E) < 0.0) {\
L\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
else {\
if ( B > C ) {\
if (B > D) {\
if (B > E) {\
N\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
}\
else {\
if ( A > B) {\
if ( A > C) {\
if (A > D) {\
if (A > E) {\
M\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
else {\
if ( B > C ) {\
if (B > D) {\
if (B > E) {\
N\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
else {\
if ( C > D ) {\
if (C > E) {\
O\
}\
else {\
Q\
}\
}\
else {\
if (D > E) {\
P\
} \
else {\
Q\
}\
}\
}\
}\
}


                    MAX5(ss, si, sd, ii[i][j].score, jj[i][j].score,
                         *pc = 0.0; *cc = ZERO;gap_ext[i][j] = 0; /*zzz++;  fprintf(stderr, "zzz\n");*/ ,
                         *pc = ss; *cc = SUBST;  gap_ext[i][j] = 0; /*aaa++; fprintf(stderr, "aaa\n");*/,
                         *pc = si; *cc = INSER;  gap_ext[i][j] = 0; /*bbb++;  fprintf(stderr, "bbb\n");*/ ,
                         *pc = sd;  *cc = DELET;  gap_ext[i][j] = 0; /*ccc++;  fprintf(stderr, "ccc\n");*/,
                         *pc = ii[i][j].score; *cc = DELET; gap_ext[i][j] = (int)(i - ii[i][j].coord); /*ddd++;  fprintf(stderr, "ddd\n");*/,
                         *pc = jj[i][j].score; *cc = INSER;  gap_ext[i][j] = j - jj[i][j].coord; /*eee++;  fprintf(stderr, "eee\n");*/
                        )



                    /*mise a jour de l'extention de gap*/

                    if (jj[i][j].score < *(pc -1) + gap_o ) {
                        jj[i][j].score = *(pc -1) + gap_o;
                        jj[i][j].coord = j-1;
                    }
                    if (ii[i][j].score < *(pc -n1 -1) + gap_o) {
                        ii[i][j].score = *(pc -n1 - 1 ) + gap_o;
                        ii[i][j].coord = i-1;
                    }


#if 0

                    /*mise a jour du tableau de bests scores !!!*/
                    /*si la case est dans le tableau, il faut verifier que la nouvelle valeur est tjs "best"*/

                    if (ancien_pc >= best_scores[*nb_best_scores-1][0]) {/*si le pc d'avant est eleve, il est dans le tableau*/
                        k=0;

                        while (k<*nb_best_scores && ((egal(best_scores[k][1],  (float)(i)) == 0) || (egal(best_scores[k][2], (float)(j)) == 0) )) /*on cherche la case qui a garde le score precedant de i et j*/
                            k++;


                        if (k < *nb_best_scores) {
                            if (*pc < best_scores[*nb_best_scores-1][0]) { /*valeur a supprimer*/
                                best_scores[k][0] = 0;
                                best_scores[k][1] = 0;
                                best_scores[k][2] = 0;
                                tri_3(best_scores, *nb_best_scores);
                                if (best_scores[0][0] <= 0.1) { /*on reremplit le tableau*/
                                    reremplit_tableau(nb_best_scores, best_scores, n1, n2, automode, pc, cc, m);


                                }
                            } else { /*on remplace la valeur*/
                                best_scores[k][0] = *pc;
                                best_scores[k][1] = i;
                                best_scores[k][2] = j;
                                tri_3(best_scores, *nb_best_scores);
                            }
                        }
                        /*                                  fprintf(stderr, " forbi \n");

                                        for(i=0; i<*nb_best_scores; i++)
                            fprintf(stderr, "%f ",best_scores[i][0]);
                        fprintf(stderr, "\n");
                        */
                    }

                    else {   /*la case n'est pas dans le tableau, on regarde si on la rajoute*/
                        if (*pc > best_scores[*nb_best_scores-1][0]) {  /*comparaison au score le plus faible*/
                            best_scores[*nb_best_scores-1][0] = *pc;
                            best_scores[*nb_best_scores-1][1] = i;
                            best_scores[*nb_best_scores-1][2] = j;
                            tri_3(best_scores, *nb_best_scores);
                        }
                    }


#endif
                    /*si on recalcule une partie de la matrice : on vrifie quand on s'arrete*/
                    if (flag == 0 && egal(*pc , ancien_pc)==1  && egal(ii[i][j].score , ancien_gap_i)==1 && egal(jj[i][j].score, ancien_gap_j)==1) { /*on est tjs identique depuis le debut*/
                        debut = j;
                    } else  {
                        flag = 1;  /*si on est different, on recalcule le reste de a ligne de toute facon */
                    }



                } /*fin else pas forbid */

            } /*fin boucle j*/
        }  /*fin boucle i*/

    }  /*fin else si on recalcule un bout de la matrice */




    if (best_scores[0][0] <= 0.0) {
        return best_scores[0][0];
    }

    /*on remplit le tableaux des meilleurs scores */
    reremplit_tableau(nb_best_scores, best_scores, n1, n2, automode, pc, cc, m);

    /*for(i=0; i<*nb_best_scores; i++)
        fprintf(stderr, "%f %f %f \n",best_scores[i][0], best_scores[i][1], best_scores[i][2] );
    fprintf(stderr, "\n");
    */
    /* sPrintMatrix(m);*/




    position =(int)(best_scores[0][1])*(n1+1) + (int)(best_scores[0][2]);


    pc = m->f + (int)(best_scores[0][1])*(n1+1) + (int)(best_scores[0][2]);

    /*
         fprintf(stderr, "***  \n");
       for(i=0; i<*nb_best_scores; i++){
        cc = m->c + (int)(best_scores[i][1])*(n1+1) + (int)(best_scores[i][2]);
            fprintf(stderr, "%f %c  ", best_scores[i][0], *cc);}
         fprintf(stderr, "\n");
    */

    if (*pc > 0.01)
        *nsub = backtracking (m, s1,  &n1, s2, &n2, posd1, posd2, posf1, posf2, s, &lastmove, gap_ext , salign,best_scores[0][1],best_scores[0][2]);
    /*calcul que si on a un match !! */
    else
        *nsub = 0;

    /*  fprintf(stderr,"=================score %f %d %d \n",best_scores[0][0] , *posd1, *posd2);  */

    /* -----------------------------------  */
    /* calcul du recouvrement       */
    /* -----------------------------------  */
    *recover = 0.0;
    if (automode) {

        /* -----------------------------------  */
        /* si recouvrement trop fort,       */
        /* on interdit pas toute la region  */
        /* (cf ci dessous) mais on      */
        /* restart (on a interdit le sous-  */
        /* alignement               */
        /* region sur p0: posd1 to bestj-1  */
        /* region sur p1: posd2 to besti-1  */
        /* -----------------------------------  */
        if ((*posd1 > *posd2) && (*posd1 < *posf2) ) {
            *recover = (float)((*posf2)-(*posd1))/(float)(*posf1-*posd1);
        } else if ((*posf1 > *posd2) && (*posf1 < *posf2) ) {
            *recover = (float)((*posf1)-(*posd2))/(float)(*posf1-*posd1);
        }

        /*
        if (*recover > tauxrecouv)
             return TOO_MUCH_RECOVER;
        */

    }

    StringReverse(salign);


#ifdef DEBUGW
    fprintf(stderr,"salign=%s\n",salign);
#endif

    return best_scores[0][0];
}





#if 0 /* abandonne */
/* ---------------------------------------------------- */
/*calcule l'axe de symetrie */
void calcule_axe_sym (COORDS *pp0, COORDS *pp1 , int lensub) {

    COORDS *axe;
    int i;
    float somme_x=0.0, somme_y=0.0, somme_z=0.0, somme_x_y=0.0, somme_x_z=0.0, somme_y_z=0.0, somme_x2=0.0, somme_y2=0.0, somme_z2=0.0;
    float coef_x, coef_y, coef_z;
    NEWY(axe,COORDS,lensub);



    for (i=0; i<lensub; i++) {
        fprintf(stderr, "1: %f %f %f 2 : %f %f %f ", pp0[i].x, pp0[i].y, pp0[i].z, pp1[i].x, pp1[i].y, pp1[i].z);
        axe[i].x = (pp0[i].x + pp1[i].x)/2;
        axe[i].y = (pp0[i].y + pp1[i].y)/2;
        axe[i].z = (pp0[i].z + pp1[i].z)/2;
        fprintf(stderr, "axe: %f %f %f \n", axe[i].x, axe[i].y, axe[i].z);
    }
    /*calcul sommes*/
    for (i=0; i<lensub; i++) {
        somme_x += axe[i].x;
        somme_y += axe[i].y;
        somme_z += axe[i].z;
        somme_x2 += axe[i].x*axe[i].x;
        somme_y2 += axe[i].y*axe[i].y;
        somme_z2 += axe[i].z*axe[i].z;
        somme_x_y += axe[i].x * axe[i].y;
        somme_x_z += axe[i].x * axe[i].z;
        somme_y_z += axe[i].y * axe[i].z;
    }

    /* y = coef_x * x + coef_z * z + coef_y  */

    coef_z = ((somme_y_z - somme_z * somme_y)*(somme_x2 - somme_x*somme_x) - (somme_x_y - somme_x*somme_y)*(somme_x_z - somme_x * somme_z)) / ((somme_z2 - somme_z*somme_z)*(somme_x2 - somme_x*somme_x) - (somme_x_z - somme_x*somme_z)*(somme_x_z - somme_x*somme_z));

    coef_x = ((somme_y_z - somme_z * somme_y)*(somme_x_z - somme_x*somme_z)-(somme_x_y - somme_x * somme_y)*(somme_z2 -somme_z*somme_z))/((somme_x_z - somme_x*somme_z)*(somme_x_z - somme_x*somme_z) - (somme_z2 - somme_z*somme_z)*(somme_x2 - somme_x*somme_x));

    coef_y = somme_y - coef_z*somme_z - coef_x*somme_x;

}
#endif




#ifdef GSL
/* ---------------------------------------------------- */
/*changement de repere pour calculer l'axe de rotation */
/* ---------------------------------------------------- */
void calcule_repere_angle_rotation (tyProt *p0,tyProt *p1,DtMatrix4x4 matrix4x, float *alpha, float *beta, float *gamma , int automode) {


    gsl_vector_complex *eval = gsl_vector_complex_alloc (3);
    gsl_matrix_complex *evec = gsl_matrix_complex_alloc (3, 3);
    gsl_eigen_nonsymmv_workspace * w = gsl_eigen_nonsymmv_alloc (3);
    int i, j, vect_ok=-1;
    double data[9] ;
    double vect_x[3], vect_y[3], vect_z[3], norma;
    DtMatrix4x4 passage ;
    double Xmean_x=0.0 , Xmean_y=0.0, Xmean_z =0.0;
    gsl_matrix_view mat;
#if 0
    DtMatrix4x4 final ;
    gsl_matrix  *inverse;
    gsl_permutation * p;
    int sign ;
#endif
    double tmp_x, tmp_y, tmp_z;



    /*calcul valeurs propres et vecteurs propres, si une valeur propre proche de 1, on garde le vecteur propre correspondant = nouveau vecteur x*/

    for (j=0; j<3; j++)
        for (i=0; i<3; i++)
            data[j*3+i] = matrix4x[i][j];

    mat  = gsl_matrix_view_array (data, 3, 3);


    /*fprintf(stderr, "coucou  %d %d %d %d \n", mat.matrix.size1, mat.matrix.size2, mat.matrix.tda, mat.matrix.owner);
         for(j=0; j<9; j++)
                fprintf(stderr, "coucou  %f \n", mat.matrix.data[j]);
    fprintf(stderr, "coucou  size  %d \n\n", (int)(mat.matrix.block));
    fflush(stderr);
    */

    gsl_eigen_nonsymmv (&mat.matrix, eval, evec, w);
    gsl_eigen_nonsymmv_free (w);
    gsl_eigen_nonsymmv_sort (eval, evec, GSL_EIGEN_SORT_ABS_DESC);
    /*     fprintf(stderr, " ok *********\n");      */
    for (i = 0; i < 3; i++)   {
        gsl_complex eval_i = gsl_vector_complex_get (eval, i);
        gsl_vector_complex_view evec_i = gsl_matrix_complex_column (evec, i);

        /* printf (stderr, "****************\neigenvalue = %g + %gi\n", GSL_REAL(eval_i), GSL_IMAG(eval_i)); */
        if (GSL_IMAG(eval_i)<= 0.00000001 && GSL_IMAG(eval_i) >= -0.0000001) {
            vect_ok = i;
            for (j = 0; j < 3; ++j)    {
                gsl_complex z = gsl_vector_complex_get(&evec_i.vector, j);
                /* fprintf(stderr, "%g + %gi\n", GSL_REAL(z), GSL_IMAG(z)); */
                vect_x[j] = GSL_REAL(z); /*on remplit le vecteur x*/
                /*          fprintf(stderr, " ok %d %g %gi \n", i,GSL_REAL(eval_i), GSL_IMAG(eval_i) );*/
            }
            /* printf (stderr, "eigenvector = \n"); */

        }

    }
    if (vect_ok == -1) { /*pas de valeur propre !!!*/
        fprintf(stderr, " pas de valeur propre !");

    } else { /*on peut continuer :*/
        gsl_vector_complex_free(eval);
        gsl_matrix_complex_free(evec);

        /*    for (i=0; i<3;i++)
                    fprintf(stderr, "vect ok !! %f \n ", vect_x[i]);

        */
        /*on calcule les vecteurs orthogonaux*/

        /*vecteur y : le produit scalaire est nul*/

        vect_y[0] = 1;
        vect_y[1] = 1;
        vect_y[2] = (-1*vect_x[0] - vect_x[1])/vect_x[2];

        norma = sqrt(vect_y[0]*vect_y[0]+vect_y[1]*vect_y[1]+vect_y[2]*vect_y[2]);
        vect_y[0] /= norma;
        vect_y[1] /= norma;
        vect_y[2] /= norma;

        /*   for (i=0; i<3;i++)
                  fprintf(stderr, "vect y !! %f \n ", vect_y[i]);*/

        /*3e vecteur : produit vectoriel */


        vect_z[0] = vect_x[1]*vect_y[2] - vect_x[2]*vect_y[1];
        vect_z[1] = vect_x[2]*vect_y[0] - vect_x[0]*vect_y[2];
        vect_z[2] = vect_x[0]*vect_y[1] - vect_x[1]*vect_y[0];

        /*     for (i=0; i<3;i++)
                    fprintf(stderr, "vect z!! %f \n ", vect_z[i]);*/

        /*on remplit la matrice de passage */

        for (i=0; i<4;i++)
            for (j=0; j<4;j++)
                passage[j][i] = 0.0;
        passage[3][3] = 1.0;

        for (i=0; i<3;i++) {
            passage[i][0] = vect_x[i];
            passage[i][1] = vect_y[i];
            passage[i][2] = vect_z[i];
        }
        /*
            for (i=0; i<3;i++)
                 for (j=0; j<3;j++)
                    fprintf(stderr, "vect %d %d !! %f \n ",i, j, passage[i][j]);
          */
#if 0
        /*on inverse la matrice de passage pour tester : */

        for (j=0; j<3; j++)
            for (i=0; i<3; i++)
                data[j*3+i] = passage[i][j];

        gsl_matrix_view passage2  = gsl_matrix_view_array (data, 3, 3);
        inverse = gsl_matrix_alloc (3, 3);
        p = gsl_permutation_alloc (3);
        gsl_matrix *invert_me = gsl_matrix_alloc(3, 3);
        gsl_matrix_memcpy (invert_me, &passage2.matrix);

        gsl_linalg_LU_decomp(invert_me, p, &sign);
        gsl_linalg_LU_invert(invert_me, p, inverse);
        gsl_permutation_free (p);

        for (i=0; i<4;i++)
            for (j=0; j<4;j++)
                passage[j][i] = 0.0;
        passage[3][3] = 1.0;
        for (j=0; j<3; j++) {
            for (i=0; i<3; i++) {
                passage[i][j] = gsl_matrix_get( inverse,i,j) ;
            }
        }
        gsl_matrix_free (inverse);
#endif

        /*affchage de la matrice de passage*/
        /*       fprintf(stderr, "v************** \n ");
         for (j=0; j<3;j++)
              for (i=0; i<3; i++)
                 fprintf(stderr, "titi %d %d !! %f \n ",i, j, passage[i][j]);
        */



        /*on modifie les coordonnees de p0 pour obtenir la bonne rotation : */

        /*on centre les coordonnees*/

        for (i=0;i<p0->nbRes;i++) {
            Xmean_x += p0->coords[i].x;
            Xmean_y += p0->coords[i].y;
            Xmean_z += p0->coords[i].z;
        }

        Xmean_x /= (double)(p0->nbRes);
        Xmean_y /= (double)(p0->nbRes);
        Xmean_z /= (double)(p0->nbRes);


        /*on fait une rotation sur les coordonnees */

        for (i=0; i<p0->nbRes; i++) {
            tmp_x = p0->coords[i].x - Xmean_x;
            tmp_y = p0->coords[i].y - Xmean_y;
            tmp_z = p0->coords[i].z - Xmean_z;
            p0->coords[i].x = tmp_x * passage[0][0] + tmp_y * passage[1][0] + tmp_z * passage[2][0] + passage[3][0];
            p0->coords[i].y = tmp_x * passage[0][1] + tmp_y * passage[1][1] + tmp_z * passage[2][1] + passage[3][1];
            p0->coords[i].z = tmp_x * passage[0][2] + tmp_y * passage[1][2] + tmp_z * passage[2][2] + passage[3][2];
        }

        if ( automode == 0 || automode == 2){ /*sim utilise nseq =2*/
            /*on modifie les coordonnees de p1 pour obtenir la bonne rotation : */
    
            /*on centre les coordonnees*/

            for (i=0;i<p1->nbRes;i++) {
                Xmean_x += p1->coords[i].x;
                Xmean_y += p1->coords[i].y;
                Xmean_z += p1->coords[i].z;
            }

            Xmean_x /= (double)(p1->nbRes);
            Xmean_y /= (double)(p1->nbRes);
            Xmean_z /= (double)(p1->nbRes);


            /*on fait une rotation sur les coordonnees */

            for (i=0; i<p1->nbRes; i++) {
                tmp_x = p1->coords[i].x - Xmean_x;
                tmp_y = p1->coords[i].y - Xmean_y;
                tmp_z = p1->coords[i].z - Xmean_z;
                p1->coords[i].x = tmp_x * passage[0][0] + tmp_y * passage[1][0] + tmp_z * passage[2][0] + passage[3][0];
                p1->coords[i].y = tmp_x * passage[0][1] + tmp_y * passage[1][1] + tmp_z * passage[2][1] + passage[3][1];
                p1->coords[i].z = tmp_x * passage[0][2] + tmp_y * passage[1][2] + tmp_z * passage[2][2] + passage[3][2];
            }
        }
        
    } /*fin de else on a une valeur propre*/

}
#endif

/* elongation de l'alignement struct*/
#define SQUARED_DISTANCE(K,R) ((K).x - (R).x) * ((K).x - (R).x) + ((K).y - (R).y) * ((K).y - (R).y) + ((K).z - (R).z) * ((K).z - (R).z)

char *elongation_alignement (tyProt *p0, tyProt *p1, int len, DtMatrix4x4 M, char *salign, int *posd0, int *posd1, int elongation) {

    int i, j, k, l, m=0, y, taille;
    char * ali = NULL;
    int len0 = 0, len1 = 0;

    NEWY(ali, char, 1000);
    ali[0] = '\0';


    for (i=0; i<len; i++) {
        if (salign[i] == 's') {
            len0++;
            len1++;
        }
        if (salign[i] == 'i') {
            len0++;
        }
        if (salign[i] == 'd') {
            len1++;
        }

    }

    for (i=*posd0 + len0, j =*posd1+len1 ;i<p0->nbRes && j<p1->nbRes;i++, j++) {
        /*     fprintf(stderr, "kiki %f\n\n\n", (float)sqrt(SQUARED_DISTANCE(p0->coords[i],crdRotate(p1->coords[j], M))));
        fprintf(stderr, "kiki %f %f %f %f %f %f  \n\n\n", p0->coords[i].x, p0->coords[i].y,  p0->coords[i].z, crdRotate(p1->coords[j],M).x,crdRotate(p1->coords[j],M).y,crdRotate(p1->coords[j],M).z);*/

        if ((float)sqrt(SQUARED_DISTANCE(p0->coords[i],crdRotate(p1->coords[j], M))) > elongation)
            break;
    }
    for (k=*posd0-1, l=*posd1 -1;k>0 && l >0 ;k--, l--) {
        /*         fprintf(stderr, "kiki %d %f\n\n\n", k, (float)sqrt(SQUARED_DISTANCE(p0->coords[k],crdRotate(p1->coords[l], M))));
        fprintf(stderr, "kiki %f %f %f %f %f %f  \n\n\n", p0->coords[k].x, p0->coords[k].y,  p0->coords[k].z, crdRotate(p1->coords[l],M).x,crdRotate(p1->coords[l],M).y,crdRotate(p1->coords[l],M).z);*/

        if ((float)sqrt(SQUARED_DISTANCE(p0->coords[k],crdRotate(p1->coords[l], M))) > elongation)
            break;
    }


    if (k < *posd0-1) { /*k forcement  =  posd0 - 1 si on allonge pas*/
        for (m=k+1; m<*posd0; m++)
            ali[m-k-1] = 's';
        /*    ali = strcat(ali, salign);*/
        for (y=0; y<strlen(salign); y++)
            ali[m-k-1+y] = salign[y];
    } else {
        /*   ali = strcpy(ali, salign);*/
        for (y=0; y<strlen(salign); y++)
            ali[y] = salign[y];
    }

    if (i > *posd0+len0) {
        for (m=*posd0+len0; m<i; m++)
            ali[m-k-1] = 's';  /*on rajoute si on a deja allonge au debut de la sequence*/

    }
    taille  = (*posd0+len0-i)+(*posd0-1-k)+(int)(strlen(salign));
    ali[taille] = '\0';
    *posd0 = k+1;
    *posd1 = l+1;


    return ali;
}


/* ---------------------------------------------------- */
/* in order to have the real RMS, one must have two vectors of coordinates        */
/* corresponding to the substitutions only (i.e. residues in front of gaps must not   */
/* be taken into account in RMS computations) */
/* MakeCoordFromAlign returns the length of alignment without indel (i.e. only    substitutions)              */
/* ---------------------------------------------------- */

int calculRMS ( int *nbpp, int **plensub, COORDS ***ppp0, COORDS ***ppp1, tyProt *p0, tyProt *p1, char *salign, double *rms, float *reverse_rms ,  SWResult*swres, float *score, float *score_blosangle, float recover, int *posd0, int *posd1, int posf0, int posf1, DtMatrix4x4 matrix4x, int *nresult, float minscore ,float minrms, int verbose, int elongation, float rrmsd, int which_rmsd, int automode) {

    double score_GL, tm_score;
    char * ali = NULL;
    float alpha = 0.0, beta=0.0, gamma=0.0;
#if 0
    DtMatrix4x4 matrice_test;
    int i, j;
    float angle1=30.0*2.1416/180, angle2=150.0*2.1416/180, angle3=60.0*2.1416/180;
    double Xmean_x =0.0, Xmean_y = 0.0, Xmean_z = 0.0;
    double tmp_x, tmp_y, tmp_z;
#endif
    double new_rms;

#undef DEBJOMPO
#ifdef DEBJOMPO
fprintf(stderr,"nbpp=%d nresult=%d\n",*nbpp,*nresult);
fprintf(stderr,"0- pp0=%X pp0[%d]=%X\n",(unsigned int)*ppp0, *nresult,(unsigned int)((*ppp0)[(*nresult)]));
#endif

    if ((*nbpp) <= (*nresult)) {
#ifdef DEBJOMPO
fprintf(stderr,"realloc pp0\n");
#endif
        TREALLOC(int, *plensub, (*nbpp)+INCPP);
        TREALLOC(COORDS *, *ppp0, (*nbpp)+INCPP);
        TREALLOC(COORDS *, *ppp1, (*nbpp)+INCPP);
        (*nbpp) += INCPP;
    }

#ifdef DEBJOMPO
fprintf(stderr,"nresult=%d nbpp=%d\n",*nresult, *nbpp);
#endif

    /* MakeCoordFromAlign allocate memory for pp0[nresult] and pp1[nresult]                         */
#if 0
    /*on modifie les coordonnees de pp0 et de pp1 juste pour tester*/

    /*on centre les coordonnees*/

    for (i=0;i<p0->nbRes;i++) {
        Xmean_x += p0->coords[i].x;
        Xmean_y += p0->coords[i].y;
        Xmean_z += p0->coords[i].z;
    }

    Xmean_x /= (double)(p0->nbRes);
    Xmean_y /= (double)(p0->nbRes);
    Xmean_z /= (double)(p0->nbRes);

    for (i=0;i<p0->nbRes;i++) {
        p0->coords[i].x -= Xmean_x;
        p0->coords[i].y -= Xmean_y;
        p0->coords[i].z -= Xmean_z ;
    }


    /*on calcule la matrice de rotation*/
    for (i =0; i<4; i++)
        for (j =0; j<4; j++)
            matrice_test[i][j] = 0.0;

    matrice_test[0][0]= cos(angle2)*cos(angle3);
    matrice_test[0][1]= cos(angle2)*sin(angle3);
    matrice_test[0][2]= -sin(angle2);
    matrice_test[1][0]= cos(angle3)*sin(angle1)*sin(angle2)-cos(angle1)*sin(angle3);
    matrice_test[1][1]= cos(angle1)*cos(angle3)+sin(angle1)*sin(angle2)*sin(angle3);
    matrice_test[1][2]= cos(angle2)*sin(angle1);
    matrice_test[2][0]= cos(angle1)*cos(angle3)*sin(angle2)+sin(angle1)*sin(angle3);
    matrice_test[2][1]= -cos(angle3)*sin(angle1)+cos(angle1)*sin(angle2)*sin(angle3);
    matrice_test[2][2]= cos(angle1)*cos(angle2);

    /*on fait une rotation sur les coordonnees */

    for (i=0; i<p0->nbRes; i++) {
        tmp_x = p0->coords[i].x ;
        tmp_y = p0->coords[i].y ;
        tmp_z = p0->coords[i].z ;
        p0->coords[i].x = tmp_x * matrice_test[0][0] + tmp_y * matrice_test[1][0] + tmp_z * matrice_test[2][0] + matrice_test[3][0];
        p0->coords[i].y = tmp_x * matrice_test[0][1] + tmp_y * matrice_test[1][1] + tmp_z * matrice_test[2][1] + matrice_test[3][1];
        p0->coords[i].z = tmp_x * matrice_test[0][2] + tmp_y * matrice_test[1][2] + tmp_z * matrice_test[2][2] + matrice_test[3][2];
    }

#endif

#ifdef DEBJOMPO
fprintf(stderr,"pp0[%d]=%X\n",*nresult,(unsigned int)((*ppp0)[(*nresult)]));
#endif

#ifdef DEBJOMPO
fprintf(stderr,"swres->nmatch=%d\n", swres->nmatch);
#endif
    (*plensub)[(*nresult)] =  MakeCoordFromAlign(&(p0->coords[*posd0]), &(p1->coords[*posd1]),
                                       salign,&((*ppp0)[(*nresult)]),&((*ppp1)[(*nresult)]));
#ifdef DEBJOMPO
fprintf(stderr,"2-swres->nmatch=%d\n", swres->nmatch);
#endif
    if ((*plensub)[(*nresult)] == -1)
        MyError(stderr,3,"swalign2: not enough memory for RMS computations\n");
    else if ((*plensub)[(*nresult)] == 0) {
        free((*ppp0)[(*nresult)]);
        free((*ppp1)[(*nresult)]);
        return 0;
    }

#ifdef DEBJOMPO
fprintf(stderr,"pp0[%d]=%X\n",*nresult,(unsigned int)((*ppp0)[(*nresult)]));
#endif

    /*    (*rms) = (float)sqrt(rms_fast((*ppp0)[(*nresult)], (*ppp1)[(*nresult)], (*plensub)[(*nresult)])); */ /* pas forcement besoin de matrixRT */

    (*rms) = (float)sqrt(zuker_superpose((*ppp0)[(*nresult)],(*ppp1)[(*nresult)] , (*plensub)[(*nresult)], matrix4x));
#ifdef DEBJOMPO
fprintf(stderr,"2-pp0[%d]=%X\n",*nresult,(unsigned int)((*ppp0)[(*nresult)]));
#endif

#ifdef GSL
    /*beta = atan2(-1 * matrix4x[0][2], sqrt(pow(matrix4x[1][2], 2) + pow(matrix4x[2][2], 2)))*180/3.1416;
    alpha = atan2(matrix4x[1][2]/cos(beta), matrix4x[2][2]/cos(beta))*180/3.1416;
    gamma = atan2(matrix4x[0][1]/cos(beta), matrix4x[0][0]/cos(beta))*180/3.1416;
    */
    /*fprintf(stdout, "alpha :  %f %f %f \n", alpha, beta, gamma);*/
    /*changement de repere pour voir la rotation de 180*/
    calcule_repere_angle_rotation ( p0, p1, matrix4x, &alpha, &beta, &gamma, automode);
#endif

    /*fonction pour ajouter ceux  moins de 1 A de distance */

    ali = elongation_alignement (p0, p1, strlen(salign), matrix4x, salign, posd0, posd1, elongation);

    free((*ppp0)[(*nresult)]);
    free((*ppp1)[(*nresult)]);

    /* MakeCoordFromAlign allocate memory for pp0[nresult] and pp1[nresult]                         */

    (*plensub)[(*nresult)] =  MakeCoordFromAlign(&(p0->coords[*posd0]), &(p1->coords[*posd1]),
                                       ali,&((*ppp0)[(*nresult)]),&((*ppp1)[(*nresult)]));

    if ((*plensub)[(*nresult)] == -1)
        MyError(stderr,3,"swalign2: not enough memory for RMS computations\n");
    else if ((*plensub)[(*nresult)] == 0) {
        free((*ppp0)[(*nresult)]);
        free((*ppp1)[(*nresult)]);
        return 0;
    }


    /*    (*rms) = (float)sqrt(rms_fast((*ppp0)[(*nresult)], (*ppp1)[(*nresult)], (*plensub)[(*nresult)])); */ /* pas forcement besoin de matrixRT */

    (*rms) = (float)sqrt(zuker_superpose((*ppp0)[(*nresult)],(*ppp1)[(*nresult)] , (*plensub)[(*nresult)], matrix4x));

#ifdef GSL
    beta = atan2(-1 * matrix4x[0][2], sqrt(pow(matrix4x[1][2], 2) + pow(matrix4x[2][2], 2)))*180/3.1416;
    alpha = atan2(matrix4x[1][2]/cos(beta), matrix4x[2][2]/cos(beta))*180/3.1416;
    gamma = atan2(matrix4x[0][1]/cos(beta), matrix4x[0][0]/cos(beta))*180/3.1416;
#endif


    /*fprintf(stdout, "alpha :  %f %f %f \n", alpha, beta, gamma);*/


    /* score gerstein levitt test*/
    /*      score_GL = calcule_score_struct(p0, p1, salign);*/

    score_GL = calcule_score_struct((*ppp0)[(*nresult)], (*ppp1)[(*nresult)], strlen(salign), (*plensub)[(*nresult)], matrix4x);

    tm_score = calcule_tm_score((*ppp0)[(*nresult)], (*ppp1)[(*nresult)], (*plensub)[(*nresult)], p0, matrix4x);
    new_rms = calcule_rms_bis( (*ppp0)[(*nresult)], (*ppp1)[(*nresult)], (*plensub)[(*nresult)], p0,p1, rms);


    /* fprintf(stderr," score GL %f\n", score_GL);*/

    /* calcule le RMS de pp1 sur pp0 etant  */
    /* donne la matrice RT calculee par */
    /* le dernier rms_fast (donc de pp0 */
    /* sur pp1)             */

    /*  (*reverse_rms) = (float)sqrt(rms_error((*ppp1)[(*nresult)],(*ppp0)[(*nresult)],(*plensub)[(*nresult)]));*/

    (*reverse_rms) = (float)sqrt(compute_RMS((*ppp1)[(*nresult)],(*ppp0)[(*nresult)],(*plensub)[(*nresult)], matrix4x));
    /*   fprintf(stderr,"&&&&&& RMS %.3f\n", *rms);*/

    if ((which_rmsd == 1 && (*rms) <= minrms) || (which_rmsd == 0 &&(new_rms) <= rrmsd) ) {

        AddSWResult(swres, *score, *rms, *reverse_rms, recover, *posd0, *posd1, posf0, posf1, ali, matrix4x, score_GL, *score_blosangle, tm_score, alpha, beta, gamma, new_rms);
        MYFREE(ali);

        (*nresult)++;
    } else {
        free((*ppp0)[(*nresult)]);
        free((*ppp1)[(*nresult)]);
        MYFREE (ali);
        (*score) = minscore+1.0;  /* dummy, just to continue  */
        return 0;
    }

#ifdef DEBJOMPO
fprintf(stderr,"3-pp0[%d]=%X\n",*nresult-1,(unsigned int)((*ppp0)[(*nresult-1)]));
#endif
    return 1;
}

#if 0
/* ---------------------------------------------------- */
static double factorielle(int k) {
    double fact = 1.0; /* note : 0! = 1 et 1! = 1 */
    int i;

    for (i = 2; i <= k; i++)
        fact *= i;

    return fact;
}

#endif
/* ---------------------------------------------------- */
double proba_water_ving(WV *water_ving, double score, int n) {

    double proba=1;
    double lambda;


    /*    fprintf(stderr," proba avant : score, water_wing->p  %f %f\n", score, water_ving->p );*/

    if (score  <=0 ||  egal(water_ving->p , 0.0))
        return -1.0;

    lambda = water_ving->gamma *  water_ving->m * water_ving->n *  pow(water_ving->p, score);

#if 0   /* on supprime la correction pour les repetitions suivantes */
    tmp=1.0;
    for (i=1; i<n+1; i++) {  /*n-1 normalement, mais ici, n est le nb de rsultats precedents, on s'arrete a n inclus*/
        tmp *= lambda/(double)(i);
        proba += tmp;

        /*proba += (double)(pow(lambda, i)) / factorielle(i);*/
        /*  fprintf(stderr," proba avant : proba, lambda, i, tmp :  %f %f %d %f \n", proba, lambda, i, tmp);*/

        /*            fprintf(stderr," proba avant : proba, lambda, i, factorielle(i), pow(lambda, i) :  %f %f %d %10f %10f         \n", proba, lambda, i, factorielle(i), pow(lambda, i));*/
    }

    proba *= exp(-lambda);
# endif


    /*            fprintf(stderr,"proba waterman_vingron g m n p lam proba score %.10f %f %f %.10f %.20f %.10f %f\n",     water_ving->gamma , water_ving->m, water_ving->n , water_ving->p, lambda, proba, score);
    */

    /*!!!!!!!!!!!!!! si on ne fait pas la correction : */
    proba = exp(-lambda);

    return proba;
}




/*********************************************************************/
/*********************************************************************/
/*     carre sw                                                      */
/*********************************************************************/
/*********************************************************************/

int carre_sw (SWResult*swres, Matrix *m, tyProt *p0, tyProt *p1, int automode, float gap_o, float gap_e, float (*gscore)(int a1, int a2, void *matthresh), void *mat_thresh,
              float tauxrecouv,float recover, int vverbose, int SPN, int nresult, float minscore, float proba_limite, float minrms,float cross_rms_seuil, int **plensub, int nbpp , COORDS  ***ppp0 , COORDS***ppp1 , WV *water_ving , int length, int elongation, float rrmsd, int which_rmsd) {


    int n, posd0, posf0, posd1, posf1; /*nb resultats, pos debut et fin*/
    int ali_len;                    /* alignment length (i.e. nb of substitution) */
    float sn,  reverse_rms;
    double rms;
    char *salign = NULL;
    DtMatrix4x4 matrix4x;
    float ** best_scores;   /*garde le score , les positions i et j des meilleurs scores*/
    int icarre =0, jcarre =0; /*positions a recalculer pour le carre*/
    int i, j, k;
    int flag_longueur = 0;  /* si la longueur du match est trop faible, mis a 1*/
    /* coord_ext **ii, **jj; */

    int compteur=0;
    int nb_best_scores = NB_BEST_SCORES_INI;  /*taille du tableau best score : variable, initialise a la taille de depart du tableau*/
    double proba =1.0; /*proba waterman vingron, est a 1 si pas de calcul de proba */
    float score =minscore + 1, score_blosangle=0;

#ifdef MEMOIRE
    char *err_msg = NULL;
#endif

#ifdef MEMOIRE
    control_prog("./swelfe", getpid(), 1000000, 100000,&err_msg) ;
    fprintf(stderr, "memtest : carre debut %d %d\n", p1->nbRes+1, p0->nbRes+1);
    fflush(stderr);
#endif

    /* formula : gap = gap_o + k*gap_e , k being overall gap length	*/
    /* so a unique gap cost gap_o+gap_e					*/
    gap_o = -(gap_o+gap_e); 
    gap_e = -gap_e;

    /*fprintf(stderr, "nb1 : %d \n ", sNb_gap_ext1);*/

    /* tout dans la meme boucle !! */
    /* memoire pour extention de gap */
    if (gap_ext == NULL) {  /* 1ere fois */
        NEWY(gap_ext, unsigned short *, (p1->nbRes+1));
        NEWY(sIi,coord_ext*,(p1->nbRes+1));
        NEWY(sJj,coord_ext*,(p1->nbRes+1));

        for (j=0; j<=p1->nbRes; j++) {
            NEWY(gap_ext[j] , unsigned short, (p0->nbRes+1));
            NEWY(sIi[j],coord_ext, (p0->nbRes+1));
            NEWY(sJj[j],coord_ext, (p0->nbRes+1));

            for (k = 0 ; k <=p0->nbRes ; k++) {
                gap_ext[j][k] = 0;
                sIi[j][k].score = gap_o;
                sIi[j][k].coord = 0;
                sJj[j][k].score = gap_o;
                sJj[j][k].coord = 0;
            }
        }
        sNb_gap_ext0 = p0->nbRes+1;
        sNb_gap_ext1 = p1->nbRes+1;
    }

    else if (p1->nbRes+1 > sNb_gap_ext1 || p0->nbRes+1 > sNb_gap_ext0) {  /*si trop petit, on free et on alloue*/
        for (j=0; j<sNb_gap_ext1; j++) {
            MYFREE(sIi[j]);
            MYFREE(sJj[j]);
            MYFREE(gap_ext[j]) ;
        }
        MYFREE(sIi);
        MYFREE(sJj);
        MYFREE(gap_ext) ;

        NEWY(gap_ext, unsigned short *, (p1->nbRes+1));
        NEWY(sIi,coord_ext*,(p1->nbRes+1));
        NEWY(sJj,coord_ext*,(p1->nbRes+1));

        for (j=0; j<=p1->nbRes; j++) {
            NEWY(gap_ext[j] , unsigned short, (p0->nbRes+1));
            NEWY(sIi[j],coord_ext, (p0->nbRes+1));
            NEWY(sJj[j],coord_ext, (p0->nbRes+1));
            for (k = 0 ; k <=p0->nbRes ; k++) {
                gap_ext[j][k] = 0;
                sIi[j][k].score = gap_o;
                sIi[j][k].coord = 0;
                sJj[j][k].score = gap_o;
                sJj[j][k].coord = 0;
            }
        }
        sNb_gap_ext0 = p0->nbRes+1;
        sNb_gap_ext1 = p1->nbRes+1;
    }



    NEWY(best_scores, float *, nb_best_scores);   /*on en garde 50 dans tous les cas*/
    for (i=0; i<nb_best_scores; i++) {
        NEWY(best_scores[i],float,3);
    }



#ifdef MEMOIRE
    fprintf(stderr, "memtest : taille : %d %d  \n", (int)(sizeof(ii)), (int)(sizeof(jj)));
#endif

#ifdef MEMOIRE
    control_prog("./swelfe", getpid(), 1000000, 100000,&err_msg) ;
    fprintf(stderr, "memtest : carre avant boucle \n");
    fflush(stderr);
#endif

    /*debut de la boucle pour faire pls alignements */
    n = 0;             /*compte le nombre de resultats trouves*/



    while ((nresult <0 || n < nresult)&& score >= minscore && (n==0 || flag_longueur == 0)) {
        /*on s'arrete quand on a le bon nombre de resultats,
         ou quand on est en dessous du score seuil et quand on est au dessus du sn minimum*/
        compteur ++;

        NEWY(salign, char, p0->nbRes+p1->nbRes);

        posd0 = posd1 = posf0 = posf1 = 0;  /*les positions de debut et fin du match sont initialisees*/


        if  (gscore == (float (*)(int a1, int a2, void *matthresh))blosum_anglescore) /*blosum angle*/

            score = alignsw_f(m, p0->tAnglesRecodes, p0->nbRes,
                              p1->tAnglesRecodes, p1->nbRes, automode, gap_o, gap_e, mat_thresh, tauxrecouv,
                              &posd0, &posd1,&posf0, &posf1, salign, &recover,gscore, best_scores, icarre+1, jcarre+1,
                              sIi, sJj, gap_ext, &nb_best_scores, &ali_len);
        else  /*score diff angle : angles pas recodes*/

            score = alignsw_f(m, p0->tAngles, p0->nbRes,
                              p1->tAngles, p1->nbRes, automode, gap_o, gap_e, mat_thresh, tauxrecouv,
                              &posd0, &posd1,&posf0, &posf1, salign, &recover,gscore, best_scores, icarre+1, jcarre+1,
                              sIi, sJj, gap_ext, &nb_best_scores, &ali_len);

        /* fprintf(stderr," $$$$$$$$$$$$$$$$$$$$$$$$$$$$$score : %f n : %d  lg %d  %d pos %d %d %d %d \n", score, compteur, ali_len, nresult, posd0, posf0, posd1, posf1); */

        /*   PrintAliSeq(stderr, p0, posd0, salign, INSER);
           PrintIdAli(stderr, p0, posd0, p1, posd1, salign, &tmp, SPN);
           PrintAliSeq(stderr, p1, posd1, salign, DELET);*/

        if (recover > tauxrecouv) {    /* restart needed   */

            fprintf(stderr,"%s %s too much overlap (%.3f), restarting... (%4d,%4d) (%4d,%4d) (score=%.2f len=%d)\n",
                    p0->nomProt, p1->nomProt, recover, posd0,posf0,posd1,posf1,score,ali_len);
            score = minscore+1.0;   /* dummy, just to continue  */
            MYFREE(salign);
            icarre = posd1;
            jcarre = posd0;
            continue;
        } else if (score < 0.01) {/*pas de match !!*/
            fprintf(stderr," pas de match score %f\n",score);
            MYFREE(salign);
            break;
        }
        if (SPN==NUCLEIQUE)
            score = score/SWADN_MULT;

        if (posf1 - posd1 != -1)
            sn = score/(posf1 - posd1 + 1.0);
        else
            sn = 100000.0;

        if (vverbose)
            fprintf(stderr,"score=%15.2f (minscore=%15.2f) normalized score = %15.2f \n", score, minscore,sn);

        if (water_ving != NULL) {
            if ((proba = proba_water_ving(water_ving, score, n) )< 0)
                fprintf(stderr," probleme proba waterman_vingron\n");
        }

        if (n >= NB_SCORES_MAX ||  score < minscore || proba < proba_limite || ali_len < length) {
            /*NB_SCORES_MAX : si prot trop repetitives, nb de tour max*/
            if (vverbose) {
               if (n >= NB_SCORES_MAX) {
                   fprintf(stderr," stop on match: step %d (nmatch=%d): score %.2f (min=%.2f) proba %.4f (lim=%.4f) len %d (minlen=%d)\n", n ,NB_SCORES_MAX , score , minscore ,proba , proba_limite , ali_len, length);
               }
               else if (score < minscore) {
                   fprintf(stderr," stop on score: step %d (nmatch=%d): score %.2f (min=%.2f) proba %.4f (lim=%.4f) len %d (minlen=%d)\n", n ,NB_SCORES_MAX , score , minscore ,proba , proba_limite , ali_len, length);
               }
               else if (proba < proba_limite) {
                   fprintf(stderr," stop on proba: step %d (nmatch=%d): score %.2f (min=%.2f) proba %.4f (lim=%.4f) len %d (minlen=%d)\n", n ,NB_SCORES_MAX , score , minscore ,proba , proba_limite , ali_len, length);
               }
               else if (ali_len < length) {
                   fprintf(stderr," stop on length: step %d (nmatch=%d): score %.2f (min=%.2f) proba %.4f (lim=%.4f) len %d (minlen=%d)\n", n ,NB_SCORES_MAX , score , minscore ,proba , proba_limite , ali_len, length);
               }
            }
            /*    fprintf(stderr," on s'arrete\n");
                  fprintf(stderr," nb %d %d score %f %f proba %f %f long %d %d\n", n ,NB_SCORES_MAX , score , minscore ,proba , proba_limite , ali_len, length);
              */
            if (ali_len < length)
                flag_longueur = 1;  /*trop petit match */
            MYFREE(salign);
            break;
        } else {
            icarre = posd1;  /*pour prendre en compte la derniere case du backtraking*/
            jcarre = posd0;
            if (SPN == STRUCTURE) {
                /* n est incremente dans calculRMS, */
                if (calculRMS ( &nbpp, plensub, ppp0, ppp1, p0, p1, salign, &rms, &reverse_rms , swres, &score, &score_blosangle,
                                recover, &posd0, &posd1, posf0, posf1, matrix4x, &n, minscore , minrms, vverbose, elongation,  rrmsd, which_rmsd, automode) == 0)
                    continue;
            } else {
                AddSWResult(swres, (float)(score), proba, -1.0, recover, posd0, posd1, posf0, posf1, salign, NULL, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
                n++ ;
            }
            MYFREE(salign);

        }   /* end if ( score < minscore)             */
    }  /*end while n<nresult*/

    /*free memory*/

    /*if (n<5){
     fprintf(stderr, "$$$$$$$$$$$$$$$$$$$ n=%d\n", n);
     sPrintMatrix(m);
     fprintf(stderr, "nres %d %d score %f %f long %d \n", nresult, n, score,  minscore,  flag_longueur) ;
    }
    */
    for (i=0; i<NB_BEST_SCORES_INI; i++)
        MYFREE(best_scores[i]);
    MYFREE(best_scores);

    return n;
}
